#!/bin/ksh
# -----------------------------------------------------------------------
# Filename:   dbcopy.ksh
# Purpose:    Copy one table between databases
# Note:       DO NOT RUN THIS SCRIPT DIRECTLY!!!
# Author:     Frank Naude (frank@ibi.co.za)
# Date:       08-Mar-2002
# -----------------------------------------------------------------------

# Change to your DB connect strings (userid/passwd@service)...
FROMCONNSTR=SYS/xxxxx\@service
TOCONNSTR=SYS/xxxxx\@service

PPID=$1		# not directly used: needed for parent to ID child processes
OWNER=$2
TABLE=$3

# -----------------------------------------------------------------------
# Add your copy method below - Sqlplus COPY and IMP/EXP works great!!!
# -----------------------------------------------------------------------

(

# --- Test method - sleep number of seconds ----------------------------
# sleep 10

# --- Sample Copy Method -----------------------------------------------
sqlplus -s /nolog <<-EOF
	connect $TOCONNSTR
	set echo on feed on pages 50000
	set arraysize 1000 copycommit 1000 
	copy from $FROMCONNSTR to $TOCONNSTR -
		replace $OWNER.$TABLE using select * from $OWNER.$TABLE;
	exit;
	EOF


# --- Sample exp/ imp method -------------------------------------------
#
# mknod /tmp/exp_${OWNER}_${TABLE}_$$.dmp p
# 
# exp $FROMCONNSTR FILE=/tmp/exp_${OWNER}_${TABLE}_$$.dmp tables=${OWNER}.${TABLE} rows=yes indexes=yes compress=no buffer=20000000 direct=y &
# 
# imp $TOCONNSTR FILE=/tmp/exp_${OWNER}_${TABLE}_$$.dmp FROMUSER=$OWNER TOUSER=$OWNER indexes=yes rows=yes commit=yes buffer=20000000 tables=${TABLE} 2>&1
#
 
) >logs/${OWNER}.${TABLE}

# Check and report for errors
grep -n 'ORA-' logs/${OWNER}.${TABLE} >>dbcopy.log
# grep 'rows imported' logs/${OWNER}.${TABLE} >>dbcopy.log

# Cleanup
# rm /tmp/exp_${OWNER}_${TABLE}_$$.dmp

